﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace WebRVDemo
{
    /// <summary>
    /// Demo application for showing Ads with the ironSource WebRV SDK through the UWP WebView control.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private RVWebView mainWebView;

        public MainPage()
        {
            this.InitializeComponent();

            string appID = "8082e2c5";// need to use the app id that were recived from the platform
            string appUserId = "user-id"; //the actual user id that is running on your application
            mainWebView = new RVWebView(webViewContainer, appID, appUserId);
            //register to the events as they are initated by the web connect page
            mainWebView.OnInit += WebRV_Init;
            mainWebView.OnClose += WebRV_Close;
            mainWebView.OnOpen += WebRV_Open;
            mainWebView.OnReady += WebRV_Ready;
            mainWebView.OnCompletion += WebRV_Completion;
            mainWebView.OnNoCampaigns += WebRV_NoCampaigns;
            mainWebView.OnError += WebRV_Error;
        }

        //Impmentation of the events actions as they are recived
        private void ShowAd_ClickAsync(object sender, RoutedEventArgs e)
        {
            mainWebView.ShowRV();
        }

        private void UpdateID_ClickAsync(object sender, RoutedEventArgs e)
        {
            mainWebView.UpdateID(textBoxAppID.Text);
            buttonShowAd.IsEnabled = false;
        }

        private void WebRV_Init(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }

        private void WebRV_Close(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }
        private void WebRV_Open(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }

        private void WebRV_Ready(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
            //In case of interstitial impmentation, can call "mainWebView.ShowRV()" immidiatly 
            buttonShowAd.IsEnabled = true;
            buttonUpdateID.IsEnabled = true;
            textBoxAppID.IsEnabled = true;
        }

        private void WebRV_Completion(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }

        private void WebRV_NoCampaigns(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }

        private void WebRV_Error(WebView sender, WebRVEventArgs args)
        {
            ShowSdkResponse(args.Message);
        }

        private async void ShowSdkResponse(string msg)
        {
            Windows.UI.Popups.MessageDialog d = new Windows.UI.Popups.MessageDialog(msg);
            await d.ShowAsync();
        }
    }
}
